=== debian/changelog ===
bedops (2.4.39+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * Add parallel.patch: toplevel Makefile should use our -jN argument.
  * Update hardening.patch: our optimization flags now override upstream -O3.

 -- Juhani Numminen <juhaninumminen0@gmail.com>  Fri, 19 Feb 2021 11:50:32 +0200

bedops (2.4.39+dfsg1-1) unstable; urgency=medium

  [ Helmut Grohne ]
  * Team upload.
  * Demote documentation deps to B-D-I. (Closes: #982965)

  [ Andreas Tille ]
  * Drop binaries from source tarball
  * Do not change interpreter path for tcsh any more

 -- Andreas Tille <tille@debian.org>  Thu, 18 Feb 2021 22:23:48 +0100
