=== debian/changelog ===
bedops (2.4.40+dfsg-1) unstable; urgency=medium

  * Team Upload.
  [ Steffen Möller ]
  * Update metadata - indent plus ref to guix

  [ Nilesh Patra ]
  * Add patch to fix FTBFS with new sphinx (Closes: #997157)

 -- Nilesh Patra <nilesh@debian.org>  Sun, 24 Oct 2021 13:20:15 +0530
